clang 10.0.0git

Classes | Namespaces | Macros
TemplateArgumentVisitor.h File Reference
`#include "clang/AST/TemplateBase.h"`
Include dependency graph for TemplateArgumentVisitor.h:
This graph shows which files directly or indirectly include this file:

Go to the source code of this file.

## Classes
class | clang::templateargumentvisitor::Base< Ref, ImplClass, RetTy, ParamTys >
| A simple visitor class that helps create template argument visitors. More...
class | clang::TemplateArgumentVisitor< ImplClass, RetTy, ParamTys >
| A simple visitor class that helps create template argument visitors. More...
class | clang::ConstTemplateArgumentVisitor< ImplClass, RetTy, ParamTys >
| A simple visitor class that helps create template argument visitors. More...

## Namespaces
| clang
| Dataflow Directional Tag Classes.
| clang::templateargumentvisitor

## Macros
#define | REF(CLASS) typename Ref<CLASS>::type
#define | DISPATCH(NAME)
#define | VISIT_METHOD(CATEGORY)

## Macro Definition Documentation

## ◆ DISPATCH

#define DISPATCH | ( |  | NAME | ) |

Value:
case TemplateArgument::NAME: \
return static_cast<ImplClass *>(this)->Visit##NAME##TemplateArgument( \
TA, std::forward<ParamTys>(P)...)
P
StringRef P
Definition: ASTMatchersInternal.cpp:485

Definition at line 28 of file TemplateArgumentVisitor.h.

Referenced by clang::templateargumentvisitor::Base< std::add_lvalue_reference, ImplClass, RetTy, ParamTys... >::Visit().

## ◆ REF

#define REF | ( |  | CLASS | ) | typename Ref<CLASS>::type

Definition at line 27 of file TemplateArgumentVisitor.h.

## ◆ VISIT_METHOD

#define VISIT_METHOD | ( |  | CATEGORY | ) |

Value:
RetTy Visit##CATEGORY##TemplateArgument(REF(TemplateArgument) TA, \
ParamTys... P) { \
return VisitTemplateArgument(TA, std::forward<ParamTys>(P)...); \
}
P
StringRef P
Definition: ASTMatchersInternal.cpp:485
REF
#define REF(CLASS)
Definition: TemplateArgumentVisitor.h:27
CATEGORY
#define CATEGORY(X, ENUM)
Definition: DiagnosticCategories.h:16

Definition at line 51 of file TemplateArgumentVisitor.h.